import matplotlib.pyplot as plt

from my_discretize_elliptic_cg import discretize_elliptic_cg
from pymor.grids.constructions import flatten_grid

from problems import h_problem


resolution = 200

p = h_problem()
diameter = 1./resolution
d, data = discretize_elliptic_cg(p, diameter=diameter)

u = d.solve()
grid = data["grid"]

subentities, coordinates, entity_map = flatten_grid(grid)
myfigure = plt.figure()
myfigure.clear()

axis = myfigure.gca()
axis.set_aspect(1)
axis.get_xaxis().set_visible(False)
axis.get_yaxis().set_visible(False)
pvariable = axis.tripcolor(coordinates[:, 0], coordinates[:, 1], subentities, u.data[0],
                           shading="gouraud", cmap="RdYlBu_r")
myfigure.set_size_inches(3, 2)
myfigure.colorbar(pvariable)
myfigure.savefig("solution.png", dpi=300, pad_inches=1)
