import simdb
import numpy as np

import matplotlib.pyplot as plt

ex_std = simdb.SimulationDatabase().select_last("exponential_convergence")
ex_g_c = simdb.SimulationDatabase().select_last("globally_coupled_convergence")

plt.yscale("log")
plt.plot(
    ex_std.d.error_energy_norm / ex_std.d.error_energy_norm[0]
    , label="online enrichment")
plt.plot(
    ex_g_c.d.error_energy_norm / ex_g_c.d.error_energy_norm[0]
    , label="globally coupled online enrichment")

plt.legend()
plt.show()

relative_energy_error = ex_g_c.d.error_energy_norm / ex_g_c.d.error_energy_norm[0]

open("errors_g_c.dat", "w").writelines(["{}\n".format(a) for a in relative_energy_error])
open("convergence_g_c.dat", "w").writelines(["{}\n".format(e) for e in (1 - relative_energy_error[1:] / relative_energy_error[:-1]) ])
