import simdb
import numpy as np

import matplotlib.pyplot as plt

ex = simdb.SimulationDatabase().select_last("exponential_convergence")

print ex.p

relative_energy_error = ex.d.error_energy_norm / ex.d.error_energy_norm[0]

relative_h1_error = ex.d.error_h1_norm / ex.d.error_h1_norm[0]

relative_l2_error = ex.d.error_l2_norm / ex.d.error_l2_norm[0]

plt.yscale("log")
plt.plot(relative_energy_error, label="energy")
plt.plot(relative_h1_error, label="h1")
plt.plot(relative_l2_error, label="l2")
plt.legend()
plt.show()

open("errors.dat", "w").writelines(["{} {} {}\n".format(a,b,c) for a,b,c in zip(relative_energy_error, relative_h1_error, relative_l2_error)])

open("convergence.dat", "w").writelines(["{}\n".format(e) for e in (1 - relative_energy_error[1:] / relative_energy_error[:-1]) ])

ineq1 = (ex.d.error_energy_norm**2 - ex.d.norm_u_l**2)[:-1] / (ex.d.error_energy_norm**2)[1:]

ineq2 = ex.d.norm_u_l**2 / ( 1./(ex.p.coarse_grid_resolution-1)**2 * np.sum(ex.d.local_residuals**2, axis=1))

cpuhz = 3.6013e7
ineq3 = cpuhz * np.sum(ex.d.local_residuals**2, axis=1) / ex.d.residual_dual_norm**2

ineq4 = ex.d.residual_dual_norm**2 / ex.d.error_energy_norm**2

rate = ex.d.error_energy_norm[1:] / ex.d.error_energy_norm[:-1]

open("ineq.dat", "w").writelines(
    ["{} {} {}\n".format(a,b,c) for a,b,c in zip(ineq1,ineq2,ineq3)]
)

plt.plot(rate)
plt.plot(np.ones(len(rate)))
plt.show()

plt.yscale("log")
plt.plot(ineq1, label="ineq1")
plt.plot(ineq2, label="ineq2")
plt.plot(ineq3, label="ineq3")
plt.plot(ineq4, label="ineq4")
plt.plot(relative_energy_error, label="error")
plt.legend()
plt.show()

ineq21 = (ex.d.error_energy_norm**2 - ex.d.norm_u_l**2)[:-1] / (ex.d.error_energy_norm**2)[1:]
ineq22 = (ex.d.error_energy_norm**2 - ( 1./(ex.p.coarse_grid_resolution-1)**2 * np.sum(ex.d.local_residuals**2, axis=1))) / (ex.d.error_energy_norm**2 - ex.d.norm_u_l**2)
ineq23 = (ex.d.error_energy_norm**2 - 1./(ex.p.coarse_grid_resolution-1)**2 * 1. / cpuhz * ex.d.residual_dual_norm**2 ) / (ex.d.error_energy_norm**2 - ( 1./(ex.p.coarse_grid_resolution-1)**2 * np.sum(ex.d.local_residuals**2, axis=1)))

plt.ylim(0.9,1.1)
plt.yscale("log")
plt.plot(np.ones(len(ineq23)))
plt.plot(ineq21, label="2.1")
plt.plot(ineq22, label="2.2")
plt.plot(ineq23, label="2.3")
plt.legend()
plt.show()
